﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.ServiceModel.Channels;
using System.Net.Security;

namespace Contracts
{
    public class NetNamedPipeContextBinding : NetNamedPipeBinding
    {
        public NetNamedPipeContextBinding() : base(){}

        public NetNamedPipeContextBinding(NetNamedPipeSecurityMode securityMode) : base(securityMode)
        {}

        public NetNamedPipeContextBinding(string configurationName) : base(configurationName)
        {}

        public override System.ServiceModel.Channels.BindingElementCollection CreateBindingElements()
        {
            BindingElementCollection baseElements = base.CreateBindingElements();
            baseElements.Insert(0, new ContextBindingElement(ProtectionLevel.EncryptAndSign, ContextExchangeMechanism.ContextSoapHeader));

            return baseElements;
        }
    }
}
