﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Contracts;
using System.ServiceModel;
using System.Threading;
using System.ServiceModel.Description;
using System.Workflow.Runtime;
using System.Workflow.Runtime.Hosting;
using System.ServiceModel.Channels;

namespace HostApplication
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window3 : Page
    {
       

        public Window3()
        {
            InitializeComponent();
        }

       
        private void Button_Click(object sender, RoutedEventArgs e)
        {

            IWorkflowInterface proxy = ((App)App.Current).localWorkflowHost.GetProxy<IWorkflowInterface>();

            proxy.SubmitOrder(
                new Order
                {
                    CustomerName = "Matt",
                    OrderID = 0,
                    OrderTotal = 250.00
                });

            wfIdText.Text = ((App)App.Current).localWorkflowHost.GetWorkflowInstanceID((IClientChannel)proxy);
            
            ((IClientChannel)proxy).Close();
        }

        

       

        

        private void Button_Click_1(object sender, RoutedEventArgs e)
        {
            Guid wfID = new Guid(wfIdText.Text);
            
            IWorkflowInterface proxy = ((App)App.Current).localWorkflowHost.GetProxy<IWorkflowInterface>(wfID);
            ((App)App.Current).localWorkflowHost.PerformClientOperationWithContext(wfID, (IClientChannel)proxy,
                () => {
            
                proxy.UpdateOrder(
                    new Order
                    {
                        CustomerName = "Matt",
                        OrderID = 2,
                        OrderTotal = 250.00,
                        OrderStatus = "Updated"
                    });
            });

        }

        
        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            HostService host =  ((App)Application.Current).localWorkflowHost.HostServiceInstance as HostService;
            if (host != null)
                this.DataContext = host;
        }
    }
}
